Index: issm/trunk-jpl/src/c/classes/objects/KML/KML_Point.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/KML/KML_Point.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/KML/KML_Point.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/io/io.h"
-#include "../../../Container/Container.h"
 #include "../../../modules/Ll2xyx/Ll2xyx.h"
 /*}}}*/
Index: issm/trunk-jpl/src/c/classes/objects/KML/KML_PolyStyle.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/KML/KML_PolyStyle.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/KML/KML_PolyStyle.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/io/io.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/KML/KML_Polygon.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/KML/KML_Polygon.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/KML/KML_Polygon.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/io/io.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/KML/KML_Style.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/KML/KML_Style.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/KML/KML_Style.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/io/io.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/KML/KML_StyleSelector.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/KML/KML_StyleSelector.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/KML/KML_StyleSelector.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/io/io.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/KML/KML_SubStyle.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/KML/KML_SubStyle.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/KML/KML_SubStyle.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/io/io.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/KML/KML_Unknown.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/KML/KML_Unknown.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/KML/KML_Unknown.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/shared.h"
 #include "../../../shared/io/io.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/Loads/Friction.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Loads/Friction.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Loads/Friction.cpp	(revision 14996)
@@ -14,5 +14,4 @@
 #include <string.h>
 #include "../../classes.h"
-#include "../../../Container/Container.h"
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
Index: issm/trunk-jpl/src/c/classes/objects/Loads/Icefront.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Loads/Icefront.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Loads/Icefront.cpp	(revision 14996)
@@ -16,6 +16,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Inputs.h"
-#include "../../../Container/Parameters.h"
 /*}}}*/	
 
Index: issm/trunk-jpl/src/c/classes/objects/Loads/Loads.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Loads/Loads.cpp	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Loads/Loads.cpp	(revision 14996)
@@ -0,0 +1,190 @@
+/*
+ * \file Loads.cpp
+ * \brief: Implementation of Loads class, derived from DataSet class.
+ */
+
+/*Headers: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <vector>
+#include <functional>
+#include <algorithm>
+#include <iostream>
+
+#include "./Loads.h"
+#include "../../../shared/shared.h"
+#include "./Load.h"
+
+using namespace std;
+/*}}}*/
+
+/*Object constructors and destructor*/
+/*FUNCTION Loads::Loads(){{{*/
+Loads::Loads(){
+	enum_type=LoadsEnum;
+	return;
+}
+/*}}}*/
+/*FUNCTION Loads::~Loads(){{{*/
+Loads::~Loads(){
+	return;
+}
+/*}}}*/
+
+/*Numerics:*/
+/*FUNCTION Loads::Configure{{{*/
+void Loads::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+
+	vector<Object*>::iterator object;
+	Load* load=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		load=dynamic_cast<Load*>(*object);
+		load->Configure(elements,loads,nodes,vertices,materials,parameters);
+
+	}
+
+}
+/*}}}*/
+/*FUNCTION Loads::IsPenalty{{{*/
+bool Loads::IsPenalty(int analysis_type){
+
+	int ispenalty=0;
+	int allispenalty=0;
+
+	/*Now go through all loads, and get how many nodes they own, unless they are clone nodes: */
+	for(int i=0;i<this->Size();i++){
+
+		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+		if (load->InAnalysis(analysis_type)){
+			if(load->IsPenalty()) ispenalty++;
+		}
+	}
+
+	/*Grab sum of all cpus: */
+#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)&ispenalty,(void*)&allispenalty,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
+	ispenalty=allispenalty;
+#endif
+
+	if(ispenalty)
+	 return true;
+	else
+	 return false;
+}
+/*}}}*/
+/*FUNCTION Loads::MaxNumNodes{{{*/
+int Loads::MaxNumNodes(int analysis_type){
+
+	int max=0;
+	int allmax;
+	int numnodes=0;
+
+	/*Now go through all loads, and get how many nodes they own, unless they are clone nodes: */
+	for(int i=0;i<this->Size();i++){
+
+		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+		if (load->InAnalysis(analysis_type)){
+			numnodes=load->GetNumberOfNodes();
+			if(numnodes>max)max=numnodes;
+		}
+	}
+
+	/*Grab max of all cpus: */
+#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)&max,(void*)&allmax,1,MPI_INT,MPI_MAX,IssmComm::GetComm());
+	max=allmax;
+#endif
+
+	return max;
+}
+/*}}}*/
+/*FUNCTION Loads::NumberOfLoads(){{{*/
+int Loads::NumberOfLoads(void){
+
+	int localloads;
+	int numberofloads;
+
+	/*Get number of local loads*/
+	localloads=this->Size();
+
+	/*figure out total number of loads combining all the cpus (no clones here)*/
+	#ifdef _HAVE_MPI_
+	MPI_Reduce(&localloads,&numberofloads,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&numberofloads,1,MPI_INT,0,IssmComm::GetComm());
+	#else
+	numberofloads=localloads;
+	#endif
+
+	return numberofloads;
+}
+/*}}}*/
+/*FUNCTION Loads::NumberOfLoads(int analysis){{{*/
+int Loads::NumberOfLoads(int analysis_type){
+
+	int localloads = 0;
+	int numberofloads;
+
+	/*Get number of local loads*/
+	for(int i=0;i<this->Size();i++){
+
+		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+
+		/*Check that this load corresponds to our analysis currently being carried out: */
+		if (load->InAnalysis(analysis_type)) localloads++;
+	}
+
+	/*figure out total number of loads combining all the cpus (no clones here)*/
+#ifdef _HAVE_MPI_
+	MPI_Reduce(&localloads,&numberofloads,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&numberofloads,1,MPI_INT,0,IssmComm::GetComm());
+#else
+	numberofloads=localloads;
+#endif
+
+	return numberofloads;
+}
+/*}}}*/
+/*FUNCTION Loads::Size(){{{*/
+int Loads::Size(void){
+
+	return this->DataSet::Size();
+}
+/*}}}*/
+/*FUNCTION Loads::Size(int analysis){{{*/
+int Loads::Size(int analysis_type){
+
+	int localloads = 0;
+
+	/*Get number of local loads*/
+	for(int i=0;i<this->Size();i++){
+
+		Load* load=dynamic_cast<Load*>(this->GetObjectByOffset(i));
+
+		/*Check that this load corresponds to our analysis currently being carried out: */
+		if (load->InAnalysis(analysis_type)) localloads++;
+	}
+
+	return localloads;
+}
+/*}}}*/
+/*FUNCTION Loads::SetCurrentConfiguration{{{*/
+void Loads::SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+
+	vector<Object*>::iterator object;
+	Load* load=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		load=dynamic_cast<Load*>(*object);
+		load->SetCurrentConfiguration(elements,loads,nodes,vertices,materials,parameters);
+
+	}
+
+}
+/*}}}*/
Index: issm/trunk-jpl/src/c/classes/objects/Loads/Loads.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Loads/Loads.h	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Loads/Loads.h	(revision 14996)
@@ -0,0 +1,36 @@
+#ifndef _CONTAINER_LOADS_H_
+#define  _CONTAINER_LOADS_H_
+
+/*forward declarations */
+#include "../DataSet.h"
+class Materials;
+class Parameters;
+class Elements;
+class Vertices;
+class Nodes;
+
+/*!\brief Declaration of Loads class.
+ *
+ * Declaration of Loads class.  Loads are vector lists (Containers) of Load objects.
+ */ 
+class Loads: public DataSet{
+
+	public:
+
+		/*constructors, destructors*/
+		Loads();
+		~Loads();
+
+		/*numerics*/
+		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		bool  IsPenalty(int analysis);
+		int   MaxNumNodes(int analysis);
+		int   NumberOfLoads(void);
+		int   NumberOfLoads(int analysis);
+		void  SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		int   Size(int analysis);
+		int   Size(void);
+
+};
+
+#endif //ifndef _LOADS_H_
Index: issm/trunk-jpl/src/c/classes/objects/Loads/Numericalflux.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Loads/Numericalflux.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Loads/Numericalflux.cpp	(revision 14996)
@@ -16,6 +16,4 @@
 #include "../../../shared/shared.h"
 #include "../../classes.h"
-#include "../../../Container/Inputs.h"
-#include "../../../Container/Parameters.h"
 /*}}}*/	
 
Index: issm/trunk-jpl/src/c/classes/objects/Loads/Pengrid.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Loads/Pengrid.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Loads/Pengrid.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/Loads/Penpair.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Loads/Penpair.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Loads/Penpair.cpp	(revision 14996)
@@ -16,5 +16,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Parameters.h"
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/Materials/Matdamageice.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Materials/Matdamageice.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Materials/Matdamageice.cpp	(revision 14996)
@@ -14,6 +14,4 @@
 #include "../../../shared/Enum/Enum.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Inputs.h"
-#include "../../../Container/Parameters.h"
 
 /*Matdamageice constructors and destructor*/
Index: issm/trunk-jpl/src/c/classes/objects/Materials/Material.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Materials/Material.h	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Materials/Material.h	(revision 14996)
@@ -12,4 +12,5 @@
 #include "../Object.h"
 #include "../../Update.h"
+class Elements;
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/Materials/Materials.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Materials/Materials.cpp	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Materials/Materials.cpp	(revision 14996)
@@ -0,0 +1,48 @@
+/*
+ * \file Materials.cpp
+ * \brief: Implementation of Materials class, derived from DataSet class.
+ */
+
+/*Headers: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./Materials.h"
+#include "../../../shared/shared.h"
+#include "./Material.h"
+
+using namespace std;
+/*}}}*/
+
+/*Object constructors and destructor*/
+/*FUNCTION Materials::Materials(){{{*/
+Materials::Materials(){
+	enum_type=MaterialsEnum;
+	return;
+}
+/*}}}*/
+/*FUNCTION Materials::~Materials(){{{*/
+Materials::~Materials(){
+	return;
+}
+/*}}}*/
+
+/*Object management*/
+/*FUNCTION Materials::Configure{{{*/
+void Materials::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+
+	vector<Object*>::iterator object;
+	Material* material=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		material=dynamic_cast<Material*>(*object);
+		material->Configure(elements);
+
+	}
+
+}
+/*}}}*/
Index: issm/trunk-jpl/src/c/classes/objects/Materials/Materials.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Materials/Materials.h	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Materials/Materials.h	(revision 14996)
@@ -0,0 +1,29 @@
+#ifndef _CONTAINER_MATERIALS_H_
+#define  _CONTAINER_MATERIALS_H_
+
+/*forward declarations */
+#include "../DataSet.h"
+class Parameters;
+class Elements;
+class Vertices;
+class Loads;
+class Nodes;
+
+/*! \brief Declaration of Materials class.
+ *
+ * Declaration of Materials class.  Materials are vector lists (Containers) of Material objects.
+ */ 
+class Materials: public DataSet{
+
+	public:
+
+		/*constructors, destructors*/
+		Materials();
+		~Materials();
+
+		/*numerics*/
+		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+
+};
+
+#endif //ifndef _MATERIALS_H_
Index: issm/trunk-jpl/src/c/classes/objects/Materials/Matice.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Materials/Matice.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Materials/Matice.cpp	(revision 14996)
@@ -11,9 +11,19 @@
 #include <stdio.h>
 #include <string.h>
-#include "../../classes.h"
-#include "../../../shared/Enum/Enum.h"
+#include "./Matice.h"
+#include "./Materials.h"
+#include "../Inputs/Input.h"
+#include "../Inputs/Inputs.h"
+#include "../Inputs/TriaP1Input.h"
+#include "../Inputs/PentaP1Input.h"
+#include "../Inputs/ControlInput.h"
+#include "../Elements/Element.h"
+#include "../Elements/Tria.h"
+#include "../Elements/Penta.h"
+#include "../Params/Parameters.h"
+#include "../../Hook.h"
+#include "../Node.h"
+#include "../../IoModel.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Inputs.h"
-#include "../../../Container/Parameters.h"
 
 /*Matice constructors and destructor*/
Index: issm/trunk-jpl/src/c/classes/objects/Materials/Matice.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Materials/Matice.h	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Materials/Matice.h	(revision 14996)
@@ -9,5 +9,14 @@
 /*{{{*/
 #include "./Material.h"
+#include "../../Hook.h"
 class IoModel;
+		
+class Elements;
+class Loads;
+class Nodes;
+class Vertices;
+class Materials;
+class Parameters;
+
 /*}}}*/
 
Index: issm/trunk-jpl/src/c/classes/objects/Node.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Node.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Node.cpp	(revision 14996)
@@ -13,5 +13,4 @@
 #include <string.h>
 #include "./objects.h"
-#include "../../Container/Container.h"
 #include "../../shared/Enum/Enum.h"
 #include "../../shared/shared.h"
Index: issm/trunk-jpl/src/c/classes/objects/Nodes.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Nodes.cpp	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Nodes.cpp	(revision 14996)
@@ -0,0 +1,355 @@
+/*
+ * \file Nodes.cpp
+ * \brief: Implementation of Nodes class, derived from DataSet class.
+ */
+
+/*Headers: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./Nodes.h"
+#include "../../shared/shared.h"
+#include "./Node.h"
+
+using namespace std;
+/*}}}*/
+
+/*Object constructors and destructor*/
+/*FUNCTION Nodes::Nodes(){{{*/
+Nodes::Nodes(){
+	enum_type=NodesEnum;
+	return;
+}
+/*}}}*/
+/*FUNCTION Nodes::~Nodes(){{{*/
+Nodes::~Nodes(){
+	return;
+}
+/*}}}*/
+
+/*Numerics*/
+/*FUNCTION Nodes::Configure{{{*/
+void Nodes::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+
+	vector<Object*>::iterator object;
+	Node* node=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		node=dynamic_cast<Node*>(*object);
+		node->Configure(nodes,vertices);
+
+	}
+
+}
+/*}}}*/
+/*FUNCTION Nodes::DistributeDofs{{{*/
+void  Nodes::DistributeDofs(int analysis_type,int setenum){
+
+	int  i;
+	int  dofcount=0;
+	int  maxdofspernode=0;
+	int* alldofcount=NULL;
+	int* truedofs=NULL;
+	int* alltruedofs=NULL;
+	int  numnodes=0;
+
+	/*recover my_rank:*/
+	int my_rank   = IssmComm::GetRank();
+	int num_procs = IssmComm::GetSize();
+
+	/*some check: */
+	_assert_(setenum==GsetEnum || setenum==FsetEnum || setenum==SsetEnum);
+
+	/*Go through objects, and distribute dofs locally, from 0 to numberofdofsperobject*/
+	for (i=0;i<this->Size();i++){
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+
+		/*Check that this node corresponds to our analysis currently being carried out: */
+		if (node->InAnalysis(analysis_type)){
+			node->DistributeDofs(&dofcount,setenum);
+		}
+	}
+
+	/* Now every object has distributed dofs, but locally, and with a dof count starting from 
+	 * 0. This means the dofs between all the cpus are not unique. We now offset the dofs of eache
+	 * cpus by the total last dofs of the previus cpu, starting from 0.
+	 * First: get number of dofs for each cpu*/
+	alldofcount=xNew<int>(num_procs);
+	#ifdef _HAVE_MPI_
+	MPI_Gather(&dofcount,1,MPI_INT,alldofcount,1,MPI_INT,0,IssmComm::GetComm());
+	MPI_Bcast(alldofcount,num_procs,MPI_INT,0,IssmComm::GetComm());
+	#else
+	alldofcount[0]=dofcount;
+	#endif
+
+	/* Every cpu should start its own dof count at the end of the dofcount from cpu-1*/
+	dofcount=0;
+	for(i=0;i<my_rank;i++){
+		dofcount+=alldofcount[i];
+	}
+	for (i=0;i<this->Size();i++){
+		/*Check that this node corresponds to our analysis currently being carried out: */
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		if (node->InAnalysis(analysis_type)){
+			node->OffsetDofs(dofcount,setenum);
+		}
+	}
+
+	/* Finally, remember that cpus may have skipped some objects, because they were clones. For every 
+	 * object that is not a clone, tell them to show their dofs, so that later on, they can get picked 
+	 * up by their clones: */
+	maxdofspernode=this->MaxNumDofs(analysis_type,setenum);
+	numnodes=this->NumberOfNodes(analysis_type);
+	if(numnodes*maxdofspernode){
+		truedofs=   xNewZeroInit<int>(numnodes*maxdofspernode); //initialize to 0, so that we can pick up the max
+		alltruedofs=xNewZeroInit<int>(numnodes*maxdofspernode);
+	}
+
+	for (i=0;i<this->Size();i++){
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		if (node->InAnalysis(analysis_type)){
+			node->ShowTrueDofs(truedofs,maxdofspernode,setenum);//give maxdofspernode, column size, so that nodes can index into truedofs
+		}
+	}
+
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)truedofs,(void*)alltruedofs,numnodes*maxdofspernode,MPI_INT,MPI_MAX,IssmComm::GetComm());
+	#else
+	for(i=0;i<numnodes*maxdofspernode;i++)alltruedofs[i]=truedofs[i];
+	#endif
+
+	/* Now every cpu knows the true dofs of everyone else that is not a clone*/
+	for (i=0;i<this->Size();i++){
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+		if (node->InAnalysis(analysis_type)){
+			node->UpdateCloneDofs(alltruedofs,maxdofspernode,setenum);
+		}
+	}
+
+	/* Free ressources: */
+	xDelete<int>(alldofcount);
+	xDelete<int>(truedofs);
+	xDelete<int>(alltruedofs);
+}
+/*}}}*/
+/*FUNCTION Nodes::FlagClones{{{*/
+void  Nodes::FlagClones(int analysis_type){
+
+	int i;
+	int num_procs;
+	int numnodes;
+
+	/*recover num_procs: */
+	num_procs=IssmComm::GetSize();
+
+	/*Figure out number of nodes for this analysis: */
+	numnodes=this->NumberOfNodes(analysis_type);
+
+	/*Allocate ranks: */
+	int* ranks    = xNew<int>(numnodes);
+	int* minranks = xNew<int>(numnodes);
+	for(i=0;i<numnodes;i++)ranks[i]=num_procs; //no cpu can have rank num_procs. This is the maximum limit.
+
+	/*Now go through all our objects and ask them to report to who they belong (which rank): */
+	Ranks(ranks,analysis_type);
+
+	/*We need to take the minimum rank for each vertex, and every cpu needs to get that result. That way, 
+	 * when we start building the dof list for all vertexs, a cpu can check whether its vertex already has been 
+	 * dealt with by another cpu. We take the minimum because we are going to manage dof assignment in increasing 
+	 * order of cpu rank. This is also why we initialized this array to num_procs.*/
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)ranks,(void*)minranks,numnodes,MPI_INT,MPI_MIN,IssmComm::GetComm());
+	#else
+	for(i=0;i<numnodes;i++)minranks[i]=ranks[i];
+	#endif
+
+	/*Now go through all objects, and use minranks to flag which objects are cloned: */
+	for(i=0;i<this->Size();i++){
+
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+
+		/*Check that this node corresponds to our analysis currently being carried out: */
+		if (node->InAnalysis(analysis_type)){
+
+			/*For this object, decide whether it is a clone: */
+			node->SetClone(minranks);
+		}
+	}
+
+	/*Free ressources: */
+	xDelete<int>(ranks); 
+	xDelete<int>(minranks);
+
+}
+/*}}}*/
+/*FUNCTION Nodes::MaxNumDofs{{{*/
+int   Nodes::MaxNumDofs(int analysis_type,int setenum){
+
+	int i;
+	int max=0;
+	int allmax;
+	int numdofs=0;
+
+	/*Now go through all nodes, and get how many dofs they own, unless they are clone nodes: */
+	for(i=0;i<this->Size();i++){
+
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+
+		/*Check that this node corresponds to our analysis currently being carried out: */
+		if (node->InAnalysis(analysis_type)){
+
+			numdofs=node->GetNumberOfDofs(NoneApproximationEnum,setenum);
+			if(numdofs>max)max=numdofs;
+		}
+	}
+
+	/*Grab max of all cpus: */
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce((void*)&max,(void*)&allmax,1,MPI_INT,MPI_MAX,IssmComm::GetComm());
+	max=allmax;
+	#endif
+
+	return max;
+}
+/*}}}*/
+/*FUNCTION Nodes::NumberOfDofs{{{*/
+int   Nodes::NumberOfDofs(int analysis_type,int setenum){
+
+	int   allnumdofs;
+
+	/*Get number of dofs on current cpu (excluding clones)*/
+	int numdofs=this->NumberOfDofsLocal(analysis_type,setenum);
+
+	/*Gather from all cpus: */
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce ( (void*)&numdofs,(void*)&allnumdofs,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
+	#else
+	allnumdofs=numdofs;
+	#endif
+	return allnumdofs;
+}
+/*}}}*/
+/*FUNCTION Nodes::NumberOfDofsLocal{{{*/
+int   Nodes::NumberOfDofsLocal(int analysis_type,int setenum){
+
+	int   numdofs=0;
+
+	/*Now go through all nodes, and get how many dofs they own, unless they are clone nodes: */
+	for(int i=0;i<this->Size();i++){
+
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+
+		/*Check that this node corresponds to our analysis currently being carried out: */
+		if (node->InAnalysis(analysis_type)){
+
+			/*Ok, this object is a node, ask it to plug values into partition: */
+			if (!node->IsClone()){
+				numdofs+=node->GetNumberOfDofs(NoneApproximationEnum,setenum);
+			}
+		}
+	}
+
+	return numdofs;
+}
+/*}}}*/
+/*FUNCTION Nodes::NumberOfNodes(){{{*/
+int Nodes::NumberOfNodes(void){
+
+	/*Careful! only use once all clones have been setup for all nodes!: */
+
+	int numnodes=0;
+	int allnumnodes=0;
+
+	/*Now go through all nodes, and get how many dofs they own, unless they are clone nodes: */
+	for(int i=0;i<this->Size();i++){
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+
+		/*Ok, this object is a node, ask it to plug values into partition: */
+		if (!node->IsClone()) numnodes++;
+	}
+
+	/*Gather from all cpus: */
+	#ifdef _HAVE_MPI_
+	MPI_Allreduce ( (void*)&numnodes,(void*)&allnumnodes,1,MPI_INT,MPI_SUM,IssmComm::GetComm());
+	#else
+	allnumnodes=numnodes;
+	#endif
+
+	return allnumnodes;
+}
+/*}}}*/
+/*FUNCTION Nodes::NumberOfNodes(analysis){{{*/
+int Nodes::NumberOfNodes(int analysis_type){
+
+	int i;
+
+	int max_sid=-1;
+	int sid;
+	int node_max_sid;
+
+	for(i=0;i<this->Size();i++){
+
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+
+		/*Check that this node corresponds to our analysis currently being carried out: */
+		if (node->InAnalysis(analysis_type)){
+
+			sid=node->Sid();
+			if (sid>max_sid)max_sid=sid;
+		}
+	}
+
+	#ifdef _HAVE_MPI_
+	MPI_Reduce (&max_sid,&node_max_sid,1,MPI_INT,MPI_MAX,0,IssmComm::GetComm() );
+	MPI_Bcast(&node_max_sid,1,MPI_INT,0,IssmComm::GetComm());
+	max_sid=node_max_sid;
+	#endif
+
+	/*sid starts at 0*/
+	max_sid++;
+
+	/*return*/
+	return max_sid;
+}
+/*}}}*/
+/*FUNCTION Nodes::Ranks{{{*/
+void   Nodes::Ranks(int* ranks,int analysis_type){
+
+	int my_rank;
+	int sid;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
+	/*Go through nodes, and for each object, report it cpu: */
+	for(int i=0;i<this->Size();i++){
+
+		Node* node=dynamic_cast<Node*>(this->GetObjectByOffset(i));
+
+		/*Check that this node corresponds to our analysis currently being carried out: */
+		if (node->InAnalysis(analysis_type)){
+			/*Plug rank into ranks, according to sid: */
+			sid=node->Sid();
+			ranks[sid]=my_rank; 
+		}
+	}
+}
+/*}}}*/
+/*FUNCTION Nodes::SetCurrentConfiguration{{{*/
+void Nodes::SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+
+	vector<Object*>::iterator object;
+	Node* node=NULL;
+
+	for (object=objects.begin() ; object < objects.end(); object++ ){
+
+		node=dynamic_cast<Node*>(*object);
+		node->SetCurrentConfiguration(nodes,vertices);
+
+	}
+}
+/*}}}*/
Index: issm/trunk-jpl/src/c/classes/objects/Nodes.h
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Nodes.h	(revision 14996)
+++ issm/trunk-jpl/src/c/classes/objects/Nodes.h	(revision 14996)
@@ -0,0 +1,41 @@
+#ifndef _CONTAINER_NODES_H_
+#define  _CONTAINER_NODES_H_
+
+#include "./DataSet.h"
+class Parameters;
+class Elements;
+class Vertices;
+class Loads;
+class Nodes;
+class Materials;
+
+
+/*!\brief Declaration of Nodes class.
+ *
+ * Declaration of Nodes class.  Nodes are vector lists of objects (Containers) of Node objects.
+ * Node objects are the degrees of freedom (DOFs) for a particular analysis type (not to be 
+ * confused with a vertex, which defines the (x,y,z) location of a point).
+ */ 
+class Nodes: public DataSet{
+
+	public:
+
+		/*constructors, destructors*/
+		Nodes();
+		~Nodes();
+
+		/*numerics*/
+		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		void  DistributeDofs(int analysis_type,int SETENUM);
+		void  FlagClones(int analysis_type);
+		int   MaxNumDofs(int analysis_type,int setenum);
+		int   NumberOfDofs(int analysis_type,int setenum);
+		int   NumberOfDofsLocal(int analysis_type,int setenum);
+		int   NumberOfNodes(int analysis_type);
+		int   NumberOfNodes(void);
+		void  Ranks(int* ranks,int analysis_type);
+		void  SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+
+};
+
+#endif //ifndef _NODES_H_
Index: issm/trunk-jpl/src/c/classes/objects/Options/OptionUtilities.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/objects/Options/OptionUtilities.cpp	(revision 14995)
+++ issm/trunk-jpl/src/c/classes/objects/Options/OptionUtilities.cpp	(revision 14996)
@@ -15,5 +15,4 @@
 #include "../objects.h"
 #include "../../../shared/shared.h"
-#include "../../../Container/Container.h"
 /*}}}*/
 
